Object.defineProperty(exports, "__esModule", { value: true });
require("@nomiclabs/hardhat-truffle5");
require("@nomiclabs/hardhat-ethers");
require("@nomiclabs/hardhat-web3");
require("hardhat-gas-reporter");
require("solidity-coverage");
const config = {
    paths: {
        artifacts: './artifacts'
    },
    solidity: {
        version: '0.7.4',
        settings: {
            optimizer: {
                enabled: true,
                runs: 100000,
                details: {
                    yul: true,
                    constantOptimizer: false
                }
            }
        }
    },
    networks: {
        ganache: {
            url: 'http://127.0.0.1:8545',
            blockGasLimit: 10000000
        },
        coverage: {
            url: 'http://localhost:8555'
        }
    },
    gasReporter: {
        enabled: !!process.env.REPORT_GAS === true,
        currency: 'USD',
        gasPrice: 21,
        showTimeSpent: true
    }
};
exports.default = config;
//# sourceMappingURL=hardhat.config.js.map